''**************************
''*  JB 2600style Driver   *
''*  (C) 2007 Jim Bagley.  *
''**************************

' Karl Albrecht
' Changed Sprite pallate number to number of lines for drawing the sprite, this makes it more like the 2600
' and made it easyer for me to manage the sprites
'
' Updated driver to handle black mazes
' Added Sprite to my ball collision, I wanted to make it pixel perfect but for now it's retangular detection


CON
  PARAM_COUNT   = 10
VAR
  long  cog
OBJ
    'dbg    :       "PASDebug"                '<---- Add for Debugger 

VAR
    long    rend_cog_number        'each cog gets a different number, starting with zero     write-only
    long    rend_cog_count         'total number of cogs                                     write-only
    long    rend_scanline_req      'a pointer to the request to put a line in the scan buffer   write-only
    long    rend_scanline_buffer   'hub memory where renderer puts scanline when requested write-only
    long    rend_scanxsize
    long    rend_scanysize
    long    rend_mode
    long    rend_tvstatus_ptr
    long    rend_lines_ptr
    long    colision_ptr

PUB Start(aCogs,TvParamsPtr,aColision_ptr) | i

    rend_cog_count := aCogs
    rend_scanline_req := long[TvParamsPtr+(14*4)]
    rend_scanline_buffer := long[TvParamsPtr+(12*4)]
    rend_scanxsize := long[TvParamsPtr+(4*4)]*4
    rend_scanysize := long[TvParamsPtr+(5*4)]*16
    rend_mode := long[TvParamsPtr+(3*4)]
    rend_tvstatus_ptr := TvParamsPtr
    rend_lines_ptr := long[TvParamsPtr+(15*4)]
    colision_ptr := aColision_ptr
    
    repeat i from 0 to aCogs-1
        rend_cog_number := i
        rend_scanline_buffer:=long[TvParamsPtr+(12*4)]+(i*(160+16))
        cognew(@entry,@rend_cog_number)
        'Wait to allow this cog to get the cog number param from the block before changing it.
        repeat 1000
    'dbg.start(31,30,@entry)                 '<---- Add for Debugger

DAT

'******************************
'* Assembly language renderer *
'******************************
                        org
'
' Entry
'
entry
  '--------- Debugger Kernel add this at Entry (Addr 0) ---------
    'long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
    'long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
  '-------------------------------------------------------------- 
                        rdlong  cog_rend_cog_number,PAR

                        mov     r0,PAR
                        movd    :load_dest1,#renderer_params+1
                        mov     count,#param_count-1
:load1                  add     r0,#4
:load_dest1             rdlong  0-0,r0
                        add     :load_dest1,inc_dest
                        djnz    count,#:load1
                        'mov   SprNbr, #$20
                        'wrlong SprNbr,cog_colision_ptr
                        
                        mov     current_line,cog_rend_cog_number  'start rendering from the top
                        test    cog_rend_mode,#%0010    wz      'if interlaced
               if_nz    add     current_line,cog_rend_cog_number
do_line

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

                        mov     r1,cog_rend_tvstatus_ptr
                        add     r1,#17*4
                        rdlong  cog_dsplst_ptr,r1
                        add     r1,#4
                        rdlong  cog_sprset_ptr,r1
                        add     r1,#4
                        mov     r0,current_line
                        rdlong  cog_scrmap_ptr,r1
                        shl     r0,#3
                        add     r1,#4
                        rdlong  cog_palette_ptr,r1
                        add     r1,#12
                        mov     tmpx,#0
                        rdlong  Myx,r1
                        mov     MYy,Myx
                        and     Myx,#$FF
                        sub     Myx,#16
                        mov     Myx32, Myx
                        add     Myx32,#32
                        shr     MYy,#8
                        and     MYy,#255
                        mov     MYy32, MYy
                        sub     MYy,#28
                        add     MYy32,#32

                        mov     Ydetect,#0
                        cmps    current_line, MYy wz,wc
              if_b      jmp     #:jpover1
                        cmps    current_line, MYy32 wz,wc
              if_a      jmp     #:jpover1
                        mov     Ydetect,#1

                                                       
:jpover1                add     cog_dsplst_ptr,r0
                        mov     destptr,cog_rend_scanline_buffer

                        rdlong  indata,cog_dsplst_ptr
                        add     cog_dsplst_ptr,#4
                        add     destptr,#8
                        
                        rdlong  indata2,cog_dsplst_ptr

                        mov     colour0,indata2
                        shr     colour0,#8
                        and     colour0,#255 wz
          if_z          jmp     #:dochars
                        mov     r0,colour0
                        shl     r0,#8
                        or      colour0,r0
                        mov     r0,colour0
                        shl     r0,#16
                        or      colour0,r0
                        mov     colourt, colour0
                        
                        mov     colour1,indata2
                        shr     colour1,#16
                        and     colour1,#255
                        mov     r0,colour1
                        shl     r0,#8
                        or      colour1,r0
                        mov     r0,colour1
                        shl     r0,#16
                        or      colour1,r0

                        mov     r0,indata
                        mov     r3,#4
                        call    #DoXLoop
                        mov     r0,indata2
                        mov     r3,#1
                        call    #DoXLoop
                        
                        jmp     #:doneline
                        
:dochars                mov     r0,current_line
                        shr     r0,#3
                        mov     r2,r0
                        shl     r2,#3
                        shl     r0,#5
                        add     r0,r2
                        add     cog_scrmap_ptr,r0
                        mov     r0,current_line
                        and     r0,#7
                        shl     r0,#2
                        add     r0,cog_sprset_ptr
                        sub     destptr,#1
                        
                        mov     r1,#20

:xloop2                 rdword  r5,cog_scrmap_ptr
                        add     cog_scrmap_ptr,#2
                        mov     r6,r5
                        shr     r6,#8-4
                        and     r5,#255
                        shl     r5,#5
                        add     r5,r0
                        rdlong  r2,r5
                        and     r6,xff0
                        add     r6,cog_palette_ptr


                        mov     r3,#8           'next byte counter
:x2loop2
                        mov     r4,r2
                        and     r4,#15
                        add     r4,r6
                        rdbyte  r4,r4
                        ror     r2,#4
                        add     destptr,#1
                        wrbyte  r4,destptr

                        djnz    r3,#:x2loop2
                        
                        djnz    r1,#:xloop2

                        rdlong  r0,cog_rend_scanline_req
                        cmp     r0,current_line wc,wz
              if_a      jmp     #gonext
                        jmp     #wait_for_the_request
                        jmp     #gonext
:doneline                        

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
' now do sprites

                        mov     r1,cog_rend_tvstatus_ptr
                        add     r1,#22*4
                        rdlong  r2,r1
                        add     r1,#4

                        rdlong  MyX,r1                          
                        mov     MyY,MyX         
                        shr     MyY,#8

                        rdlong  SprColreg,cog_colision_ptr

                        and     MyY,#255
                        and     MyX,#255
                        add     MyY,#7
                        add     MyX,#4
                                                
                        mov     SprNbr,#0
:spriteslp              rdlong  tmpx,r1
                        mov     tmpy,tmpx
                        mov     tmpL,tmpx
                        mov     tmpc,tmpx

                        shr     tmpy,#8
                        'sar     tmpy,#8
                        and     tmpy,#255
                        mov     tmps,current_line wc
                        sub     tmps,tmpy wc

              if_c      jmp     #:skpspr
                        shr     tmpL,#16
                        and     tmpL,#$ff
                        cmp     tmps,tmpL wc,wz

              if_a      jmp     #:skpspr
                        and     tmpx,#255
                        add     tmpx,#8
                        cmp     tmpx,#168 wc,wz

              if_ae     jmp     #:skpspr
                        sub     tmpx,#8

                        mov     tmpp,cog_palette_ptr
                        shr     tmpc,#24
                        and     tmpc,#255
                        
' Try colision detection                        
                        'sub    MyY,#7
                        cmp     SprNbr,#0 wz
              if_e      jmp     #:skpcolsionCheck
                        cmp     SprColreg,#0 wz
              if_ne     jmp     #:skpcolsionCheck
                        'sub    tmpy,#7
                        'mov    Ydetect,#0
        ' Y  Colision Detection
             '          cmp     current_line,#108 wz,wc
              'if_ne    jmp     #:skpcolsionCheck
                                'mov     tmpy,current_line wc
                        sub     MyY,tmpy wz,wc
               if_b     jmp     #:AddY
                        add     tmpL,#7       
                        cmp     MyY,tmpL wz,wc
               if_a     jmp     #:AddY                                  

                        sub     Myx,tmpx wz,wc
               if_b     jmp      #:AddX
                        'add     tmpx,#4
                        cmp      Myx,#12 wz,wc
                        'sub     tmpx,#4
               if_a     jmp      #:AddX                                  
                        wrlong    SprNbr,cog_colision_ptr
                        'mov     SprColreg,#1
                        'mov    Ydetect,#1     
                        'add     MyY,#7
:AddX                   add     MyX,tmpx
:AddY                   add     MyY,tmpy
:skpcolsionCheck        mov     destptr,cog_rend_scanline_buffer
                        add     destptr,#8-1
                        add     destptr,tmpx

                        mov     tmpL,tmps
                        'sub     tmps,#1
                        shr     tmpL,#3         ' / 8
                        shl     tmpL,#10        ' x 1024 - 32 bytes per char x 32 chars per line

                        and     tmps,#7
                        shl     tmps,#2         ' x 4 -  4 bytes per line
                                                
                        shl     tmpc,#5         ' x 32 - 32 byte per char
                        add     tmpc,tmps
                        add     tmpc, tmpL      ' add line offset
                        add     tmpc,cog_sprset_ptr

                        rdlong  r0,tmpc
                        mov     r3,#8           'next byte counter
:sx2loop
                        mov     r4,r0
                        and     r4,#15 wz
                        add     r4,tmpp
                        rdbyte  r4,r4
                        add     destptr,#1
                        ror     r0,#4
              if_nz     wrbyte  r4,destptr
              'if_nz    call    #testxcolison
                        add     tmpx,#1
                        djnz    r3,#:sx2loop

:skpspr                 add     r1,#4

                        rdlong  r0,cog_rend_scanline_req
                        cmp     r0,current_line wc,wz
              if_a      jmp     #gonext

                        add     SprNbr,#1
                        djnz    r2,#:spriteslp                                      

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

wait_for_the_request    rdlong  r0,cog_rend_scanline_req
                        cmp     r0,current_line wz
              if_nz     jmp     #wait_for_the_request
wait_for_the_request2   rdlong  r0,cog_rend_scanline_req
                        cmp     r0,current_line wz
              if_z      jmp     #wait_for_the_request2

'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

gonext                  add     current_line,cog_rend_cog_count 'we only do every Nth line
                        test    cog_rend_mode,#%0010    wz      'if interlaced
              if_nz     add     current_line,cog_rend_cog_count
              
                        cmp     current_line,cog_rend_scanysize wc,wz
              if_b      jmp     #do_line

                        mov     r0,cog_rend_tvstatus_ptr
                        add     r0,#16*4
:wait_lp                rdlong  r1,r0
                        cmp     r1,#1 wz
              if_nz     jmp     #:wait_lp

                        test    cog_rend_mode,#%0010    wz      'if interlaced
              if_nz     jmp     #start_interlaced
                        mov     current_line,cog_rend_cog_number
                        jmp     #do_line
start_interlaced
                        mov     r0,cog_rend_tvstatus_ptr
                        add     r0,#1
                        rdbyte  current_line,r0
                        and     current_line,#1
                        add     current_line,cog_rend_cog_number
                        add     current_line,cog_rend_cog_number
                        jmp     #do_line

DoXLoop                 mov     r2,#8

:xlp                    mov     colour0, colourt
                        cmp     colour0, colour1 wz,wc
              if_ne     jmp     #:xlp1     
                        cmp     Ydetect, #1 wz,wc
              if_ne     jmp     #:xlp1
                        cmps    tmpx, Myx wz,wc
              if_b      jmp     #:xlp1
                        cmps    tmpx, Myx32 wz,wc
              if_a      jmp     #:xlp1
                        mov     colour0, colourh

:xlp1                  test    r0,#128 wz

                        mov     data,colour0
              if_nz     mov     data,colour1
                        wrlong  data,destptr
                        add     tmpx, #4
                        rol     r0,#1
                        add     destptr,#4
                        djnz    r2,#:xlp
                        ror     r0,#16
                        djnz    r3,#DoXLoop
DoXLoop_ret             ret                        
                        

testxcolison            cmp     Ydetect,#1 wz
              if_ne     jmp     #testxcolison_ret
                        cmp     SprNbr,#0 wz
              if_e      jmp     #testxcolison_ret                     
                        cmp     SprColreg,#0 wz
              if_ne     jmp     #testxcolison_ret                     
                        cmp     MyX, tmpx wz, wc
              if_b      jmp     #testxcolison_ret
                        add     tmpx,#4
                        cmp     MyX, tmpx wz, wc
                        sub     tmpx,#4
              if_a      jmp     #testxcolison_ret
                        wrlong  SprNbr,cog_colision_ptr
testxcolison_ret        ret
'-------------------------------------------------------------------

' Initialized data
black                   long    $02_02_02_02
end_of_location_array   long    $FFFF_FFFF
char_set_start          long    $8000
ffffff00                long    $FFFFFF00
fff                     long    $FFF
inc_dest                long    1 << 9 << 0

xffff   long  $ffff
xff0    long  $ff0

indata  byte  %10101010,%10101010,%10101010,%10101010
indata2 byte  %10101010,$02,$2b,$02
   
colour0 long  $02020202
colour1 long  $2b2b2b2b
colour2 long  $2b2b2b2b
colourt long  $00000000
colourh long  $ADADADAD
' End of scanline buffer
scanline_req            long    0

DAT 'Uninitiaised data - always keep it at the end of file to avoid nasty gotcha with RES.

renderer_params  
cog_rend_cog_number             res 1 'each cog gets a different number, starting with zero     write-only
cog_rend_cog_count              res 1 'total number of cogs                                     write-only
cog_rend_scanline_req           res 1 'a pointer to the request to put a line in the scan buffer   write-only
cog_rend_scanline_buffer        res 1 'hub memory where renderer puts scanline when requested write-only
cog_rend_scanxsize              res 1
cog_rend_scanysize              res 1
cog_rend_mode                   res 1
cog_rend_tvstatus_ptr           res 1
cog_rend_lines_ptr              res 1
cog_colision_ptr                res 1                
    
cog_dsplst_ptr          res     1        
cog_sprset_ptr          res     1
cog_palette_ptr         res     1
cog_scrmap_ptr          res     1
        
current_line            res     1
r0                      res     1
r1                      res     1
r2                      res     1
r3                      res     1
r4                      res     1
r5                      res     1
r6                      res     1
count                   res     1
_mode                   res     1

destptr                 res     1
tmpx                    res     1
tmpy                    res     1
tmpp                    res     1
tmpc                    res     1
tmpL                    res     1
tmps                    res     1
MyX                     res     1
Myx32                   res     1
MyY                     res     1
MyY32                   res     1
data                    res     1
SprNbr                  res     1
SprColreg               res     1
Ydetect                 res     1

                        fit
                        