CON
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]

    GP_RIGHT  = %00000001
    GP_LEFT   = %00000010
    GP_DOWN   = %00000100
    GP_UP     = %00001000
    GP_START  = %00010000
    GP_SELECT = %00100000
    GP_B      = %01000000
    GP_A      = %10000000

VAR
    byte BaseKeyPadPin


PUB Start(BasePin)
    BaseKeyPadPin := BasePin
    'key.start(14)


PUB NES_Read_Gamepad : nes_bits        |  i
   
  ' set I/O ports to proper direction
  ' P3 = JOY_CLK    (4)
  ' P4 = JOY_SH/LDn (5) 
  ' P5 = JOY_DATAOUT0 (6)
  ' P6 = JOY_DATAOUT1 (7)
  ' NES Bit Encoding
   
  ' step 1: set I/Os
  DIRA [BaseKeyPadPin] := 1 ' output
  DIRA [BaseKeyPadPin+1] := 1 ' output
  DIRA [BaseKeyPadPin+2] := 0 ' input
  DIRA [BaseKeyPadPin+3] := 0 ' input
   
  ' step 2: set clock and latch to 0
  OUTA [BaseKeyPadPin] := 0 ' JOY_CLK = 0
  OUTA [BaseKeyPadPin+1] := 0 ' JOY_SH/LDn = 0
  'Delay(1)
   
  ' step 3: set latch to 1
  OUTA [BaseKeyPadPin+1] := 1 ' JOY_SH/LDn = 1
  'Delay(1)
   
  ' step 4: set latch to 0
  OUTA [BaseKeyPadPin+1] := 0 ' JOY_SH/LDn = 0
   
  ' step 5: read first bit of each game pad
   
  ' data is now ready to shift out
  ' first bit is ready
  nes_bits := 0
   
  ' left controller
  nes_bits := INA[BaseKeyPadPin+2] | (INA[BaseKeyPadPin+3] << 8)
   
  ' step 7: read next 7 bits
  repeat i from 0 to 6
   OUTA [BaseKeyPadPin] := 1 ' JOY_CLK = 1
   'Delay(1)           
   OUTA [BaseKeyPadPin] := 0 ' JOY_CLK = 0
   nes_bits := (nes_bits << 1)
   nes_bits := nes_bits | INA[BaseKeyPadPin+2] | (INA[BaseKeyPadPin+3] << 8)
   
  waitcnt(50_000 + cnt)
   
  ' Keyboard (mapped onto NES buttons)
  {
   
  if(key.keystate($C3))       'Up Arrow
      nes_bits:=GP_UP


   if(key.keystate($C2))   'Down Arrow
      nes_bits:=GP_Down
    if(key.keystate($C1))     'Left Arrow
      nes_bits:=GP_LEFT
    if(key.keystate($C0))     'Right Arrow
      nes_bits:=GP_RIGHT
  ' if(key.keystate($0D))      'Enter
  '  nes_bits|=NES0_START
    if(key.keystate(" "))      'Space
      nes_bits:=GP_B
   }
   
   
   'Delay(1)           
  ' invert bits to make positive logic
  nes_bits := (!nes_bits & $FFFF)
   
  ' //////////////////////////////////////////////////////////////////
  ' End NES Game Paddle Read
  ' //////////////////////////////////////////////////////////////////
   
              